' "<$fbc>" -dll "<$file>" -x ..\CapturePlugin.dll
#include "\Basic4GL\Basic4GLMacros.bi"
#include "windows.bi"
#include "GL/gl.bi"
#include "GL/glu.bi"
#include "avicapture.bi"
const PLUG_DESC = "for Basic4GL"
const PLUG_MAJOR = 0
const PLUG_MINOR = 1


dim shared as string     errormsg
dim shared as integer    InUse,IsExe

extern "C"

DPF(CaptureStart) '   as function (file as zstring ptr,w as integer,h as integer,fps) as integer
  dim as zstring ptr pf=GSP(4)
  dim as string f=*pf
  InUse=avi_start(f,GIP(3),GIP(2),GIP(1),cast(integer,FindWindow("gbOPENGL",NULL)))
  SIR(InUse)
end sub
DPF(CaptureFrame) '        as sub ()
  if InUse then avi_capture_gl
end sub
DPF(CaptureEnd) '       as sub()
  if InUse then 
    avi_end
    InUse=0
  end if
end sub
' ##########
' # Plugin #
' ##########

function Load (THIS_PLUGIN, _
               THIS_REGISTRY, _
               blnIsExe as byte) as integer

  RIF(CaptureStart):ASP:AIP:AIP:AIP
  RVF(CaptureFrame)
  RVF(CaptureEnd)

  return 1
end function

sub Unload (THIS_PLUGIN)
  if InUse then 
    avi_end
    InUse=0
  end if
end sub

function Start (THIS_PLUGIN) as integer
  return 1
end function

sub      Ends (THIS_PLUGIN)
  if InUse then
    beep 
    avi_end
    InUse=0
  end if
end sub

sub      Pause (THIS_PLUGIN)

end sub

sub      Resumed (THIS_PLUGIN)

end sub

sub      DelayedResume (THIS_PLUGIN)

end sub

sub      GetError  (THIS_PLUGIN,ErrMsg as zstring ptr)
  if len(errormsg) then
    for i as integer=0 to len(errormsg)-1
      ErrMsg[i]=errormsg[i]
    next
  end if
end sub

sub      ProcessMessages(THIS_PLUGIN)

end sub

' Query function
function Basic4GL_Query  alias "Basic4GL_Query" (byval details as string, _
                                                 byref major   as integer, _
                                                 byref minor   as integer) as integer export
  dim as string detailSrc = PLUG_DESC
  for i as integer = 0 to len(detailSrc)
    details[i] = detailSrc[i]
  next
  major = PLUG_MAJOR
  minor = PLUG_MINOR
  return BASIC4GL_DLL_VERSION
end function

dim shared as IDLL_Basic4GL_Plugin ptr Plugin
' Main initialisation function.
' Here we will construct and return our plugin object
function Basic4GL_Init  alias "Basic4GL_Init" () as IDLL_Basic4GL_Plugin ptr ptr export
  Plugin=new IDLL_Basic4GL_Plugin
  ' Construct and return our plugin object
  Plugin->Load           =@Load
  Plugin->Unload         =@Unload
  Plugin->Start          =@Start
  Plugin->Ends           =@Ends
  Plugin->Pause          =@Pause
  Plugin->Resumed        =@Resumed
  Plugin->DelayedResume  =@DelayedResume
  Plugin->GetError       =@GetError
  Plugin->ProcessMessages=@ProcessMessages

  return @Plugin
end function

end extern
